django/blog_project/mysite/blog/urls.py
from django.contrib import admin
from django.urls import path
from blog import views
app_name = 'blog'
urlpatterns = [
    path('about/', views.AboutView.as_view(), name='about'),
    path('', views.PostListView.as_view(), name='post_list'),
    path('post/<str:pk>', views.PostDetailView.as_view(), name='post_detail'),
    path('post/new/', views.PostCreateView.as_view(), name='post_new'),
    path('post/<str:pk>/edit', views.PostUpdateView.as_view(), name='post_update'),
    path('post/<str:pk>/remove', views.PostDeleteView.as_view(), name='post_remove'),
    path('drafts/', views.DraftListView.as_view(), name='post_draft_list'),
    path('post/<str:pk>/comment', views.add_comment_to_post, name='add_comment_to_post'),
    path('comment/<str:pk>/approve', views.comment_aprove, name='comment_approve'),
    path('comment/<str:pk>/remove', views.comment_remove, name='comment_remove'),
    path('post/<str:pk>/publish', views.post_publish, name='post_publish'),

]

django/blog_project/mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path
from django.urls.conf import include
from django.contrib.auth import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('blog/', include('blog.urls')),
    path('accounts/login/', views.LoginView.as_view(), name='login', kwargs={'next_page':'../../blog/post_list'}),
    path('accounts/logout/', views.LogoutView.as_view(), name='logout', kwargs={'next_page':''}),
]

django/blog_project/mysite/blog/models.py
from django.db import models
from django.utils import timezone
from django.urls import reverse

class Post(models.Model):
    author = models.ForeignKey('auth.User', on_delete=True)
    title = models.CharField(max_length=100)
    text = models.TextField(max_length=10000)
    create_date = models.DateTimeField(timezone.now())
    published_date = models.DateTimeField(blank=True, null=True)

    def __str__(self):
        return self.author

    def publish(self):
        self.published_date = timezone.now()
        self.save()
    
    def approve_comment(self):
        return self.comments.filter(approved_comment=True)
    
    def get_absolute_url(self):
        return reverse("post_detail", kwargs={"pk": self.pk})
    


class Comment(models.Model):
    post = models.ForeignKey('blog.Post', on_delete=True)
    author = models.CharField(max_length=100)
    text = models.TextField(max_length=1000)
    create_date = models.DateTimeField(timezone.now())
    approved_comment = models.BooleanField(default=False)

    def approve(self):
        self.approved_comment = True
        self.save()
    
    def __str__(self):
        return self.text
    
    def get_absolute_url(self):
        return reverse("post_list")
    

django/blog_project/mysite/blog/forms.py
from datetime import time
from django.db import models
from django.db.models import fields
from django.forms import widgets
from blog.models import Comment, Post
from django import forms

class PostForm(forms.ModelForm):

    class Meta():
        model = Post
        fields = ('author', 'title', 'text')
        widgets = {
            'title' : forms.TextInput(attrs={'class':'textinputclass'}),
            'text' : forms.Textarea(attrs={'class':'editable medium-editor-textarea postcontent'}) 
        }

class CommentForm(forms.ModelForm):
    
    class Meta():
        model = Comment
        fields = ('author', 'text')
        widgets = {
            'author' : forms.TextInput(attrs={'class':'textinputclass'}),
            'text' : forms.Textarea(attrs={'class':'editable medium-editor-textarea'}) 
        }

django/blog_project/mysite/blog/views.py
from datetime import time, timezone
from django.shortcuts import render,get_object_or_404, redirect
from blog.models import Post, Comment
from blog.forms import PostForm, CommentForm
from django.utils import timezone
from django.urls import reverse_lazy
from django.contrib.auth.decorators import login_required

from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import (TemplateView, ListView, 
                    UpdateView, DetailView, CreateView, DeleteView)



class AboutView(TemplateView):
    template_name = 'about.html'

class PostListView(ListView):
    template_name = 'post_list.html'
    model = Post
    def get_queryset(self):
        return Post.objects.filter(published_date__lte=timezone.now()).order_by('-published_date')

class PostDetailView(DetailView):
    model = Post
    template = ''

class PostCreateView(LoginRequiredMixin, DetailView):
    model = Post
    login_url = '/login/'
    form_class = PostForm
    redirect_field_name = 'post_detail.html'


class PostUpdateView(LoginRequiredMixin, UpdateView):
    model = Post
    login_url = '/login/'
    form_class = PostForm
    redirect_field_name = 'post_detail.html'


class PostDeleteView(LoginRequiredMixin, DeleteView):
    model = Post
    success_url = reverse_lazy('post_list')


class DraftListView(LoginRequiredMixin, ListView):
    login_url = '/login/'
    redirect_field_name = 'blog/post_list.html'
    model = Post

    def get_queryset(self):
        return Post.objects.filter(published_date__isnull=True).order_by('created_date')
    
################
################
@login_required
def post_publish(request, pk):
    post = get_object_or_404(Post, pk=pk)
    post.publish
    return redirect('post_detail', pk = post.pk)


@login_required
def add_comment_to_post(request, pk):
    post = get_object_or_404(Post, pk=pk)
    if request.method == 'POST':
        form = CommentForm(request.POST)
        if form.is_valid:
            comment = form.save(commit=False)
            comment.post = post
            comment.save()
            return redirect('post_detail', pk = post.pk)
    else:
        form = CommentForm()
    return render(request, 'blog/comment_form.html', {'form':form})


@login_required
def comment_aprove(request, pk):
    comment = get_object_or_404(Comment,pk=pk)
    comment.approve
    return redirect('post_detail')

@login_required
def comment_remove(request, pk):
    comment = get_object_or_404(Comment, pk=pk)
    post_pk = comment.post.pk
    comment.delete
    return redirect('post_detail', pk = post_pk)

django/blog_project/mysite/blog/templates/blog/about.html
{%extends 'blog/base.html'%}
{%block content%}
<h1>This is about company!</h1>
{%endblock%}

django/blog_project/mysite/blog/templates/blog/base.html
<!DOCTYPE html>
{%load staticfiles%}
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- CSS only -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <!-- JavaScript Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <script src="//cdn.jsdelivr.net/npm/medium-editor@latest/dist/js/medium-editor.min.js"></script>
    <link rel="stylesheet" href="//cdn.jsdelivr.net/npm/medium-editor@latest/dist/css/medium-editor.min.css" type="text/css" media="screen" charset="utf-8">
    <link rel="stylesheet" href="{%static 'css/blog.css' %}">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Trirong">

    <title>Base</title>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light techfont custom-navbar">
        <div class="container">
            <ul class="nav navbar-nav">
                <li><a class="navbar-brand bigbrand" href="{%url 'blog:post_list'%}">Brand</a></li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'blog:about' %}">About</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="https://about.gitlab.com/">Gitlab</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="https://www.facebook.com/">Facebook</a>
                </li>         
            </ul>
            <ul class="nav navbar-nav navbar-right">
                {%if user.is_authenticated%}
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'blog:post_new' %}">New post</a>
                </li>   
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'blog:post_draft_list' %}">Drafts</a>
                </li>  
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'logout' %}">Log out</a>
                </li>     
                <li class="nav-item ">
                    <a>Welcome {{user.username}}</a>
                </li>  
                {%else%}
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'login' %}"><span class="glyphicon glyphicon-user" ></span></a>
                </li> 
                {%endif%}
            </ul>
        </div>
    </nav>
    <div class="content container">
        <div class="row">
            <div class="blog_post">
                {%block content%}
                {%endblock%}
            </div>
        </div>
    </div>
    
</body>
</html>

django/blog_project/mysite/blog/templates/blog/comment_form.html
{%extends 'base.html' %}
{%block content%}

{%endblock%}

django/blog_project/mysite/blog/templates/blog/post.html
{%extends 'base.html'%}
{%block content%}

{%endblock%}

django/blog_project/mysite/blog/templates/blog/post_confirm_delete.html
{%extends 'blog/base.html'%}
{%block content%}

{%endblock%}

django/blog_project/mysite/blog/templates/blog/post_detail.html
{%extends 'blog/base.html'%}
{%block content%}

{%endblock%}

django/blog_project/mysite/blog/templates/blog/post_draft_list.html
{%extends 'blog/base.html'%}
{%block content%}

{%endblock%}

django/blog_project/mysite/blog/templates/blog/post_form.html
{%extends 'blog/base.html'%}
{%block content%}

{%endblock%}

django/blog_project/mysite/blog/templates/blog/post_list.html
{%extends 'base.html'%}
{%block content%}
<div class="centerstage">
    {%for post in post_list%}
</div>
{%endblock%}